
(define
	(domain blocksworld)
	(:requirements
		:strips :typing
	)
	(:types
		block
	)
	(:predicates
		(on ?x ?y - block)
		(ontable ?x - block)
		(clear ?x - block)
		(handempty)
		(holding ?x - block)
	)
	(:action pick-up
		:parameters (?x - block)
		:precondition
			(and
				(clear ?x)
				(ontable ?x)
				(handempty)
			)
		:effect
			(and
				(not (ontable ?x))
				(not (clear ?x))
				(not (handempty))
				(holding ?x)
			)
	)
	(:action put-down
		:parameters (?x - block)
		:precondition
			(and (holding ?x))
		:effect
			(and
				(not (holding ?x))
				(clear ?x)
				(handempty)
				(ontable ?x)
			)
	)
	(:action stack
		:parameters (?x ?y - block)
		:precondition
			(and
				(holding ?x)
				(clear ?y)
			)
		:effect
			(and
				(not (holding ?x))
				(not (clear ?y))
				(clear ?x)
				(handempty)
				(on ?x ?y)
			)
	)
	(:action unstack
		:parameters (?x ?y - block)
		:precondition
			(and
				(on ?x ?y)
				(clear ?x)
				(handempty)
			)
		:effect
			(and
				(holding ?x)
				(clear ?y)
				(not (clear ?x))
				(not (handempty))
				(not (on ?x ?y))
			)
	)
;|	(:macro
		(:action chunk-7-0
			:parameters (?b6 ?b4 - block)
			:precondition
				(and
					(on ?b6 ?b4)
					(clear ?b6)
					(handempty)
				)
			:effect
				(and
					(clear ?b4)
					(not (on ?b6 ?b4))
					(ontable ?b6)
				)
;|			:permutation
;|				(unstack ?b6 ?b4)
;|				(put-down ?b6)
		)
;|	)
)

