
(define
	(domain blocksworld)
	(:requirements
		:strips :typing
	)
	(:types
		block
	)
	(:predicates
		(on ?x ?y - block)
		(ontable ?x - block)
		(clear ?x - block)
		(handempty)
		(holding ?x - block)
	)
	(:action pick-up
		:parameters (?x - block)
		:precondition
			(and
				(clear ?x)
				(ontable ?x)
				(handempty)
			)
		:effect
			(and
				(not (ontable ?x))
				(not (clear ?x))
				(not (handempty))
				(holding ?x)
			)
	)
	(:action put-down
		:parameters (?x - block)
		:precondition
			(and (holding ?x))
		:effect
			(and
				(not (holding ?x))
				(clear ?x)
				(handempty)
				(ontable ?x)
			)
	)
	(:action stack
		:parameters (?x ?y - block)
		:precondition
			(and
				(holding ?x)
				(clear ?y)
			)
		:effect
			(and
				(not (holding ?x))
				(not (clear ?y))
				(clear ?x)
				(handempty)
				(on ?x ?y)
			)
	)
	(:action unstack
		:parameters (?x ?y - block)
		:precondition
			(and
				(on ?x ?y)
				(clear ?x)
				(handempty)
			)
		:effect
			(and
				(holding ?x)
				(clear ?y)
				(not (clear ?x))
				(not (handempty))
				(not (on ?x ?y))
			)
	)
;|	(:macro
		(:action chunk-0-0-4
			:parameters (?b12 ?b2 - block)
			:precondition
				(and
					(clear ?b12)
					(ontable ?b12)
					(handempty)
					(clear ?b2)
				)
			:effect
				(and
					(not (ontable ?b12))
					(not (clear ?b2))
					(on ?b12 ?b2)
				)
;|			:permutation
;|				(pick-up ?b12)
;|				(stack ?b12 ?b2)
		)
;|	)
)

