
(define
	(domain blocksworld)
	(:requirements
		:strips :typing
	)
	(:types
		block
	)
	(:predicates
		(on ?x ?y - block)
		(ontable ?x - block)
		(clear ?x - block)
		(handempty)
		(holding ?x - block)
	)
	(:action pick-up
		:parameters (?x - block)
		:precondition
			(and
				(clear ?x)
				(ontable ?x)
				(handempty)
			)
		:effect
			(and
				(not (ontable ?x))
				(not (clear ?x))
				(not (handempty))
				(holding ?x)
			)
	)
	(:action put-down
		:parameters (?x - block)
		:precondition
			(and (holding ?x))
		:effect
			(and
				(not (holding ?x))
				(clear ?x)
				(handempty)
				(ontable ?x)
			)
	)
	(:action stack
		:parameters (?x ?y - block)
		:precondition
			(and
				(holding ?x)
				(clear ?y)
			)
		:effect
			(and
				(not (holding ?x))
				(not (clear ?y))
				(clear ?x)
				(handempty)
				(on ?x ?y)
			)
	)
	(:action unstack
		:parameters (?x ?y - block)
		:precondition
			(and
				(on ?x ?y)
				(clear ?x)
				(handempty)
			)
		:effect
			(and
				(holding ?x)
				(clear ?y)
				(not (clear ?x))
				(not (handempty))
				(not (on ?x ?y))
			)
	)
;|	(:macro
		(:action chunk-2-3
			:parameters (?b8 ?b20 - block)
			:precondition
				(and
					(on ?b8 ?b20)
					(clear ?b8)
					(handempty)
					(ontable ?b20)
				)
			:effect
				(and
					(not (handempty))
					(not (on ?b8 ?b20))
					(ontable ?b8)
					(not (ontable ?b20))
					(holding ?b20)
				)
;|			:permutation
;|				(unstack ?b8 ?b20)
;|				(put-down ?b8)
;|				(pick-up ?b20)
		)
;|	)
)

