
(define
	(domain blocksworld)
	(:requirements
		:strips :typing
	)
	(:types
		block
	)
	(:predicates
		(on ?x ?y - block)
		(ontable ?x - block)
		(clear ?x - block)
		(handempty)
		(holding ?x - block)
	)
	(:action pick-up
		:parameters (?x - block)
		:precondition
			(and
				(clear ?x)
				(ontable ?x)
				(handempty)
			)
		:effect
			(and
				(not (ontable ?x))
				(not (clear ?x))
				(not (handempty))
				(holding ?x)
			)
	)
	(:action put-down
		:parameters (?x - block)
		:precondition
			(and (holding ?x))
		:effect
			(and
				(not (holding ?x))
				(clear ?x)
				(handempty)
				(ontable ?x)
			)
	)
	(:action stack
		:parameters (?x ?y - block)
		:precondition
			(and
				(holding ?x)
				(clear ?y)
			)
		:effect
			(and
				(not (holding ?x))
				(not (clear ?y))
				(clear ?x)
				(handempty)
				(on ?x ?y)
			)
	)
	(:action unstack
		:parameters (?x ?y - block)
		:precondition
			(and
				(on ?x ?y)
				(clear ?x)
				(handempty)
			)
		:effect
			(and
				(holding ?x)
				(clear ?y)
				(not (clear ?x))
				(not (handempty))
				(not (on ?x ?y))
			)
	)
;|	(:macro
		(:action chunk-7-4-67
			:parameters (?b10 ?b2 - block)
			:precondition
				(and
					(on ?b10 ?b2)
					(clear ?b10)
					(handempty)
				)
			:effect
				(and
					(clear ?b2)
					(not (on ?b10 ?b2))
					(ontable ?b10)
				)
;|			:permutation
;|				(unstack ?b10 ?b2)
;|				(put-down ?b10)
		)
;|	)
;|	(:macro
		(:action chunk-0-2-8
			:parameters (?b2 ?b1 - block)
			:precondition
				(and
					(clear ?b2)
					(ontable ?b2)
					(handempty)
					(clear ?b1)
				)
			:effect
				(and
					(not (ontable ?b2))
					(not (clear ?b1))
					(on ?b2 ?b1)
				)
;|			:permutation
;|				(pick-up ?b2)
;|				(stack ?b2 ?b1)
		)
;|	)
)

