
(define
	(domain blocksworld)
	(:requirements
		:strips :typing
	)
	(:types
		block
	)
	(:predicates
		(on ?x ?y - block)
		(ontable ?x - block)
		(clear ?x - block)
		(handempty)
		(holding ?x - block)
	)
	(:action pick-up
		:parameters (?x - block)
		:precondition
			(and
				(clear ?x)
				(ontable ?x)
				(handempty)
			)
		:effect
			(and
				(not (ontable ?x))
				(not (clear ?x))
				(not (handempty))
				(holding ?x)
			)
	)
	(:action put-down
		:parameters (?x - block)
		:precondition
			(and (holding ?x))
		:effect
			(and
				(not (holding ?x))
				(clear ?x)
				(handempty)
				(ontable ?x)
			)
	)
	(:action stack
		:parameters (?x ?y - block)
		:precondition
			(and
				(holding ?x)
				(clear ?y)
			)
		:effect
			(and
				(not (holding ?x))
				(not (clear ?y))
				(clear ?x)
				(handempty)
				(on ?x ?y)
			)
	)
	(:action unstack
		:parameters (?x ?y - block)
		:precondition
			(and
				(on ?x ?y)
				(clear ?x)
				(handempty)
			)
		:effect
			(and
				(holding ?x)
				(clear ?y)
				(not (clear ?x))
				(not (handempty))
				(not (on ?x ?y))
			)
	)
;|	(:macro
		(:action chunk-2-3
			:parameters (?b26 ?b4 - block)
			:precondition
				(and
					(clear ?b26)
					(ontable ?b26)
					(handempty)
					(clear ?b4)
				)
			:effect
				(and
					(not (ontable ?b26))
					(not (clear ?b4))
					(on ?b26 ?b4)
				)
;|			:permutation
;|				(pick-up ?b26)
;|				(stack ?b26 ?b4)
		)
;|	)
;|	(:macro
		(:action chunk-5-4
			:parameters (?b18 ?b12 - block)
			:precondition
				(and
					(on ?b18 ?b12)
					(clear ?b18)
					(handempty)
				)
			:effect
				(and
					(clear ?b12)
					(not (on ?b18 ?b12))
					(ontable ?b18)
				)
;|			:permutation
;|				(unstack ?b18 ?b12)
;|				(put-down ?b18)
		)
;|	)
)

